(function () {

	var ZeedhiDirectives = angular.module("ZeedhiDirectives");

	ZeedhiDirectives.directive("zhBindTranslate", ["ScreenService", "eventAggregator", zhBindTranslateDirective]);

	function zhBindTranslateDirective(ScreenService, eventAggregator) {
		return {
			compile: function (templateElement) {
				templateElement.addClass('ng-binding');

				return function (scope, element, attr) {
					var originalValue;
					element.data('$binding', attr.zhBindTranslate);

					eventAggregator.subscribe('onChangeLanguage', function() {
						zhBindTranslateWatchAction(element, originalValue);
					});

					scope.$watch(attr.zhBindTranslate, function(value) {
						originalValue = value;
						zhBindTranslateWatchAction(element, value);
					});
				};

				function zhBindTranslateWatchAction(element, value) {
					element.text(Util.isUndefinedOrNull(value) ? "" : ScreenService.i18n(value));
				}
			}
		};
	}

})();