var ZhHelper = {
	doAsyncTest: function(callBack, callBackAssertions, _timeout, $rootScope, $httpBackend, callFush) {
		var timeout = _timeout || 5000;
		var processed = false;
		setTimeout(function() {
			if ($rootScope) {
				$rootScope.$apply();
			}
			if (callBackAssertions) {
				callBackAssertions();
			}
		}, 300);
		callBack(function() {
			processed = true;
		});
		if(!(callFush === false)){
			//try{
				$httpBackend.flush();
			//}catch(e){}
		}/*
		waitsFor(function() {
			return processed;
		}, timeout);*/
	},
	emptyContainer: {
		widgets: [{
			name: "empty",
			fields: [],
			dataSources: {},
			events: []
		}]
	},
	emptyEnvironment: {},
	securityApply: function($rootScope){
	    try {
	        $rootScope.$apply();
	    } catch (e) {}
	},
	buildMock: function() {
		var mock = {
			whenSuccess: function() {},
			whenError: function() {}
		};
		spyOn(mock, 'whenSuccess').and.callThrough();
		spyOn(mock, 'whenError').and.callThrough();
		return mock;
	},
	repositoryRequestMock: function(name, dataset) {
		var dataSource = {
			dataset: {}
		};
		dataSource.dataset[name] = dataset || [];
		return dataSource;
	},
	projectTest:  function () {
		return {
			"zeedhi_project": {
				"name": "ZeedhiDemo",
				"label": "ZeedhiDemo",
				"showMenu": true,
				"showHeader": true,
				"componentMessages": "component/messages.html",
				"footer": "component/footer-edit-wizard.html",
				"mainWindow": "login",
				"logLevel": "DEBUG",
				"aclEnable": true,
				"usePostData": false,
				"defaultLanguage": "pt_br",
				"groupMenu": [{
					"name": "dashboard",
					"label": "Dashboard",
					"hasChild": true,
					"menus": [{
						"label": "Dashboard",
						"windowName": "dashboard",
						"icon": "home icon-white"
					}]
				}, {
					"label": "Stuff",
					"name": "stuff",
					"hasChild": true,
					"isVisible": true,
					"menus": [{
						"name": "applications",
						"label": "Aplicações",
						"icon": "application icon-white",
						"hasChild": true,
						"isVisible": true,
						"menus": [{
							"name": "list",
							"label": "List",
							"isVisible": true,
							"windowName": "list"
						}, {
							"name": "gridWithActions",
							"label": "Grid with actions",
							"isVisible": true,
							"windowName": "grid-with-actions"
						}, {
							"name": "treeGridWithActions",
							"label": "Tree Grid with actions and styles",
							"isVisible": true,
							"windowName": "tree-grid-with-actions"
						}, {
							"name": "phoneInput",
							"label": "Phone input",
							"isVisible": true,
							"windowName": "phone-input"
						}, {
							"name": "select",
							"label": "Select fields",
							"isVisible": true,
							"windowName": "select"
						}, {
							"name": "numbers",
							"label": "Numbers",
							"isVisible": true,
							"windowName": "number"
						}, {
							"label": "Colors",
							"isVisible": true,
							"windowName": "colors"
						}, {
							"label": "FieldGroup",
							"isVisible": true,
							"windowName": "fieldGroup"
						}, {
							"label": "Notification Message",
							"windowName": "notifications",
							"isVisible": true
						}, {
							"label": "Add dynamically fields with mask",
							"isVisible": true,
							"windowName": "add-fields-with-mask"
						}, {
							"label": "Menu 3",
							"name": "aclTestMenu",
							"label": "Acl test",
							"isVisible": true,
							"windowName": "acl-test"
						}, {
							"label": "Photo",
							"name": "Phot",
							"isVisible": true,
							"windowName": "photo"
						}, {
							"label": "Chart(s)",
							"name": "Chars",
							"isVisible": true,
							"windowName": "chart"
						}, {
							"name": "list-grouped",
							"label": "ListGrouped",
							"isVisible": true,
							"windowName": "list-grouped"
						}]
					}]
				}],
				"notifications": [{
					"id": 1,
					"name": "appropriation",
					"icon": "clock",
					"events": [{
						"name": "NotificationEvent",
						"code": "ScreenService.alertNotification('Processamento em segundo plano falhou.');",
						"id": 1
					}]
				}, {
					"id": 2,
					"name": "solicitations",
					"icon": "cell",
					"events": [{
						"name": "NotificationEvent",
						"code": "ScreenService.successNotification('Processamento em segundo plano falhou.');",
						"id": 1
					}]
				}]
			}
		};
	},
	generateData: function(length){
		var data = [];
	    for (var i = 0; i < length; i++) {
	        data.push({ "id": i, "name": 'Afghanistan '+i, "propA": "Afghanistan "+(i+10), changed: true});
	    }
	    data.push({"id": length, "name": 'Afghanistan 1000', "propA": null, changed: true});
    	return data;
	},
	saveDataInDataSource: function(localStorageEngine, dataSourceName, length){
		return localStorageEngine.save(dataSourceName, ZhHelper.generateData(length));
	},
	clearDataSource: function(localStorageEngine, dataSourceName){
		return localStorageEngine.remove(dataSourceName, []);
	},
	reloadDataSource: function(localStorageEngine, dataSourceName, length){
		length = length || 1000;
		return ZhHelper.clearDataSource(localStorageEngine, dataSourceName).then(function(){
			return ZhHelper.saveDataInDataSource(localStorageEngine, dataSourceName, length);
		});
	},
	baseContainerWithTwoWidgets: function () {
		return {
			"widgets": [{
				"name": "tabbedWidget",
				"template": "widget/tabbedWidget.html",
				"events": [],
				"dataSource": {
					"name": "/test",
					"data": []
				},
				"widgets": [
					{
						"name": "imageChild",
						"template": "widget/grid.html",
						"fields": [{
							"name": "image",
							"source": "images/zeedhi-demo.svg",
							"size": 10,
							"class": "10 col-xs-offset-1",
							"isVisible": true,
							"template": "field/image-static.html",
							"dataSource" : {},
							"mask": {
								"type": "zerofill"
							}
						}]
					},
					{
						"name": "imageSecondChild",
						"template": "widget/grid.html",
						"fields": [{
							"name": "secondImage",
							"source": "images/zeedhi-demo.svg",
							"size": 10,
							"class": "10 col-xs-offset-1",
							"isVisible": true,
							"template": "field/image-static.html",
							"dataSource" : {},
							"mask": {
								"type": "zerofill"
							}
						}]
					}
				],
				"active": true,
				"actions": []
			}]
		};
	},
	getTestDataSourceDataWithNames: function getgetTestDataSourceDataWithNamesTestDataSourceData() {
		return [{
			"name" : "Rodrigo Cesar dsfnajk",
			"birth" : "12/12/12",
			"genre" : "Masculino",
			"last" : "Paul  dsaffdsao",
			"category" : "",
			"hu" : "123"
		},{
			"name" : "Rodrigo Cesar abc crazy",
			"birth" : "12/12/12",
			"genre" : "Masculino",
			"last" : "Paul  dsaffdsao",
			"hu" : "fadfdas"
		},{
			"name" : "Rodrigo dsfnajk",
			"birth" : "12/12/12",
			"genre" : "Masculino",
			"last" : "Paul ",
			"hu" : "fadfdas"
		},{
			"name" : "fdasfdas  dsfnajk",
			"birth" : "12/12/12",
			"genre" : "Masculino",
			"last" : "Paul  dsaffdsao",
			"hu" : "fadfdas"
		},{
			"name" : "Rodrigo Cesar dsfnajk",
			"birth" : "12/12/12",
			"genre" : "Masculino",
			"last" : "Paul  dsaffdsao",
			"hu" : "1234"
		},{
			"name" : "Rodrigo Cesar dsfnajk",
			"birth" : "12/12/12",
			"genre" : "Masculino",
			"last" : "Paul  dsaffdsao",
			"hu" : "fadfdas"
		},{
			"name" : "Rodrigo Cesar dsfnajk",
			"birth" : "12/12/12",
			"genre" : "Masculino",
			"last" : "Paul  dsaffdsao",
			"hu" : "fadfdas"
		},{
			"name" : "Rodrigo Cesar dsfnajk",
			"birth" : "12/12/12",
			"genre" : "Masculino",
			"last" : "Paul  dsaffdsao",
			"hu" : "fadfdas"
		},{
			"name" : "Rodrigo Cesar dsfnajk",
			"birth" : "12/12/12",
			"genre" : "Masculino",
			"last" : "Paul  dsaffdsao",
			"hu" : "THE UNIQUE VALUE OF HU"
		}];
	},
	baseFields: function () {
		return [{
			name: "name",
			isVisible: true,
			aclIsVisible: true,
			showOnList: true,
			skipSearch: false,
		}, {
			name: "birth",
			isVisible: true,
			aclIsVisible: true,
			showOnList: true,
			skipSearch: false,
		}, {
			name: "genre",
			isVisible: true,
			aclIsVisible: true,
			showOnList: true,
			skipSearch: false,
		}, {
			name: "last",
			isVisible: true,
			aclIsVisible: true,
			showOnList: true,
			skipSearch: false,
		}, {
			name: "hu",
			isVisible: true,
			aclIsVisible: true,
			showOnList: true,
			skipSearch: false,
		}];
	}
};