describe('zhMasonryGrid', function() {

	var $compile;
	var $scope;
	var timeout = jasmine.createSpy('$timeout').and.callFake(function(callback, timer) {
		callback();
	});

	beforeEach(function() {
		module('ZeedhiServices', function ($provide) {
			$provide.value('$timeout', timeout);
		});
		module('ZeedhiDirectives');
		inject(function(_$compile_, _$rootScope_) {
			$compile = _$compile_;
			$scope = _$rootScope_.$new();
		});
	});
	
	it('should execute methods in the right moment', function() {
		$scope.widget = $compile('<div class="zh-dashboard-widget" id="masonry-item-1" ></div>')($scope);
		var dashboard = $compile('<div zh-masonry-grid zh-masonry-grid-order ></div>')($scope);
		
		$scope.initializeGrid([$scope.widget]);
		$scope.grid.is = function(param){
			expect(param).toBe(':visible');
			return true;
		};
		spyOn($scope.grid, 'positionAllBlocksOnDashboard').and.callFake(function() {
			expect(timeout).toHaveBeenCalledWith(jasmine.any(Function), undefined);
		}).and.callThrough();
		$(window).trigger('resize');

		expect(timeout).toHaveBeenCalledWith(jasmine.any(Function), 500);
	});
});